/* sx.h */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "mspec.h"

// memory  cs[1000], ds[2000], ss[7000]
//        ^          ^        ^         ^
//        0       MAXCS      SSBASE    MAXMEM

#define	MAXCS 2000
#define MAXDS 50000
#define SSBASE 60000
#define MAXMEM 100000

#define MWIDTH   MAWIDTH+MCWIDTH
//#define MWIDTH	100	// max size  define in mspec.h
//#define MLEN		100

#define PRIVATE   static

#define icAdd 1
#define icSub 2
#define icMul 3
#define icDiv 4
#define icBand 5
#define icBor 6
#define icBxor 7
#define icNot 8
#define icEq 9
#define icNe 10
#define icLt 11
#define icLe 12
#define icGe 13
#define icGt 14
#define icShl 15
#define icShr 16
//#define icMod 17
#define icLdx 18
#define icStx 19
#define icRet 20
//#define icRetv 21
#define icArray 22
#define icEnd 23
#define icGet 24
#define icPut 25
#define icLd 26
#define icSt 27
#define icJmp 28
#define icJt 29
#define icJf 30
#define icLit 31
#define icCall 32
//#define icCallt 33
#define icInc 34
#define icDec 35
#define icSys 36
//#define icCase 37
#define icFun 38
#define icJne 39
#define icLdxv 40
#define icStxv 41
#define icSeqi 42

#define FP1 50		// alu pass1
#define FP2 51		// alu pass2
#define FZ  52		// alu eq 0
#define FSUB 53		// alu p1 - p2

#define OBJ_SOMv2  5678920

#define eqs(a,b)  (strcmp(a,b)==0)

typedef struct {
	char name[80];
	int val;
} sym;

typedef struct {
	char name[80];
	int type;
	int ref;
} symt;

void error(char *s);
void trap(int op, int arg);

int alu(int op, int a, int b);
void readmpgm(void);
void run3(void);
void show(void);
void showR(void);
void loadobj(char *fn);
void interp(void);
void readmspec(void);
void initrom(void);
void trace(void);
void scan1(int a);

int xalloc(int a);
void readinfile(void);
void tokenise(void);
void prList( int e);

extern int TS, FP, SP, NX, FF, PC, IR, Z, S, M[];
extern int tbus, dbus, p1, p2, abus;
extern int mpc;
extern char ms[];
extern int runflag;
extern int clock, ninst;
extern int disp;

extern sym mads[];
extern int mwidth, mawidth, mcwidth, mlen;

// n-code

#define xIF 1
#define xWHILE 2
#define xDO 3
#define xNEW 5
#define xADD 6
#define xSUB 7
#define xMUL 8
#define xDIV 9
#define xEQ 10
#define xLT 11
#define xGT 12
#define xCALL 13
#define xGET 14
#define xPUT 15
#define xLIT 16
#define xLDX 17
#define xSTX 18
#define xFUN 19
#define xSYS 20
#define ySET 21		// keyword
#define ySETV 22	// keyword
#define yVEC 23		// keyword
//#define yLET 24		// keyword
#define xLD 25
#define xST 26
#define xLDY 27
#define xSTY 28
//#define ySEM 29
//#define yMAC 30		// macro def
//#define yMX 31		// macro expansion
#define xSTR 32
#define xBAND 33
#define xSHR 34
#define xSHL 35

char *findName(int ty, int ref);
void prOp(FILE *fo, int op);
void prCode(FILE *fo, int code, int ip);

